/*
    This is a romfs file system driver for Windows NT and Windows 2000,
    pre-release 2000-07-11.
    Copyright (C) 2000 Bo Branten
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "ntifs.h"
#include "fsd.h"

BOOLEAN
FsdFastIoCheckIfPossible (
    IN PFILE_OBJECT         FileObject,
    IN PLARGE_INTEGER       FileOffset,
    IN ULONG                Length,
    IN BOOLEAN              Wait,
    IN ULONG                LockKey,
    IN BOOLEAN              CheckForReadOperation,
    OUT PIO_STATUS_BLOCK    IoStatus,
    IN PDEVICE_OBJECT       DeviceObject
    )
{
    KdPrint((DRIVER_NAME ": FASTIO_CHECK_IF_POSSIBLE\n"));

    return FALSE;
}

BOOLEAN
FsdFastIoRead (
    IN PFILE_OBJECT         FileObject,
    IN PLARGE_INTEGER       FileOffset,
    IN ULONG                Length,
    IN BOOLEAN              Wait,
    IN ULONG                LockKey,
    OUT PVOID               Buffer,
    OUT PIO_STATUS_BLOCK    IoStatus,
    IN PDEVICE_OBJECT       DeviceObject
    )
{
    KdPrint((DRIVER_NAME ": FASTIO_READ\n"));

    return FALSE;
}

BOOLEAN
FsdFastIoWrite (
    IN PFILE_OBJECT         FileObject,
    IN PLARGE_INTEGER       FileOffset,
    IN ULONG                Length,
    IN BOOLEAN              Wait,
    IN ULONG                LockKey,
    IN PVOID                Buffer,
    OUT PIO_STATUS_BLOCK    IoStatus,
    IN PDEVICE_OBJECT       DeviceObject
    )
{
    KdPrint((DRIVER_NAME ": FASTIO_WRITE\n"));

    return FALSE;
}

BOOLEAN
FsdFastIoQueryBasicInfo (
    IN PFILE_OBJECT             FileObject,
    IN BOOLEAN                  Wait,
    OUT PFILE_BASIC_INFORMATION Buffer,
    OUT PIO_STATUS_BLOCK        IoStatus,
    IN PDEVICE_OBJECT           DeviceObject
    )
{
    KdPrint((DRIVER_NAME ": FASTIO_QUERY_BASIC_INFO\n"));

    return FALSE;
}

BOOLEAN
FsdFastIoQueryStandardInfo (
    IN PFILE_OBJECT                 FileObject,
    IN BOOLEAN                      Wait,
    OUT PFILE_STANDARD_INFORMATION  Buffer,
    OUT PIO_STATUS_BLOCK            IoStatus,
    IN PDEVICE_OBJECT               DeviceObject
    )
{
    KdPrint((DRIVER_NAME ": FASTIO_QUERY_STANDARD_INFO\n"));

    return FALSE;
}

BOOLEAN
FsdFastIoLock (
    IN PFILE_OBJECT         FileObject,
    IN PLARGE_INTEGER       FileOffset,
    IN PLARGE_INTEGER       Length,
    IN PEPROCESS            ProcessId,
    IN ULONG                Key,
    IN BOOLEAN              FailImmediately,
    IN BOOLEAN              ExclusiveLock,
    OUT PIO_STATUS_BLOCK    IoStatus,
    IN PDEVICE_OBJECT       DeviceObject
    )
{
    KdPrint((DRIVER_NAME ": FASTIO_LOCK\n"));

    return FALSE;
}

BOOLEAN
FsdFastIoUnlockSingle (
    IN PFILE_OBJECT         FileObject,
    IN PLARGE_INTEGER       FileOffset,
    IN PLARGE_INTEGER       Length,
    IN PEPROCESS            ProcessId,
    IN ULONG                Key,
    OUT PIO_STATUS_BLOCK    IoStatus,
    IN PDEVICE_OBJECT       DeviceObject
    )
{
    KdPrint((DRIVER_NAME ": FASTIO_UNLOCK_SINGLE\n"));

    return FALSE;
}

BOOLEAN
FsdFastIoUnlockAll (
    IN PFILE_OBJECT         FileObject,
    IN PEPROCESS            ProcessId,
    OUT PIO_STATUS_BLOCK    IoStatus,
    IN PDEVICE_OBJECT       DeviceObject
    )
{
    KdPrint((DRIVER_NAME ": FASTIO_UNLOCK_ALL\n"));

    return FALSE;
}

BOOLEAN
FsdFastIoUnlockAllByKey (
    IN PFILE_OBJECT         FileObject,
    IN PEPROCESS            ProcessId,
    IN ULONG                Key,
    OUT PIO_STATUS_BLOCK    IoStatus,
    IN PDEVICE_OBJECT       DeviceObject
    )
{
    KdPrint((DRIVER_NAME ": FASTIO_UNLOCK_ALL_BY_KEY\n"));

    return FALSE;
}

BOOLEAN
FsdFastIoDeviceControl (
    IN PFILE_OBJECT         FileObject,
    IN BOOLEAN              Wait,
    IN PVOID                InputBuffer OPTIONAL,
    IN ULONG                InputBufferLength,
    OUT PVOID               OutputBuffer OPTIONAL,
    IN ULONG                OutputBufferLength,
    IN ULONG                IoControlCode,
    OUT PIO_STATUS_BLOCK    IoStatus,
    IN PDEVICE_OBJECT       DeviceObject
    )
{
    KdPrint((DRIVER_NAME ": FASTIO_DEVICE_CONTROL\n"));

    return FALSE;
}

VOID
FsdFastIoAcquireFileForNtCreateSection (
    IN PFILE_OBJECT FileObject
    )
{
    KdPrint((DRIVER_NAME ": FASTIO_ACQUIRE_FILE_FOR_NT_CREATE_SECTION\n"));
}

VOID
FsdFastIoReleaseFileForNtCreateSection (
    IN PFILE_OBJECT FileObject
    )
{
    KdPrint((DRIVER_NAME ": FASTIO_RELEASE_FILE_FOR_NT_CREATE_SECTION\n"));
}

VOID
FsdFastIoDetachDevice (
    IN PDEVICE_OBJECT SourceDevice,
    IN PDEVICE_OBJECT TargetDevice
    )
{
    KdPrint((DRIVER_NAME ": FASTIO_DETACH_DEVICE\n"));
}

BOOLEAN
FsdFastIoQueryNetworkOpenInfo (
    IN PFILE_OBJECT                     FileObject,
    IN BOOLEAN                          Wait,
    OUT PFILE_NETWORK_OPEN_INFORMATION  Buffer,
    OUT PIO_STATUS_BLOCK                IoStatus,
    IN PDEVICE_OBJECT                   DeviceObject
    )
{
    KdPrint((DRIVER_NAME ": FASTIO_QUERY_NETWORK_OPEN_INFO\n"));

    return FALSE;
}

BOOLEAN
FsdFastIoMdlRead (
    IN PFILE_OBJECT         FileObject,
    IN PLARGE_INTEGER       FileOffset,
    IN ULONG                Length,
    IN ULONG                LockKey,
    OUT PMDL                *MdlChain,
    OUT PIO_STATUS_BLOCK    IoStatus,
    IN PDEVICE_OBJECT       DeviceObject
    )
{
    KdPrint((DRIVER_NAME ": FASTIO_MDL_READ\n"));

    return FALSE;
}

BOOLEAN
FsdFastIoMdlReadComplete (
    IN PFILE_OBJECT     FileObject,
    IN PMDL             MdlChain,
    IN PDEVICE_OBJECT   DeviceObject
    )
{
    KdPrint((DRIVER_NAME ": FASTIO_MDL_READ_COMPLETE\n"));

    return FALSE;
}

BOOLEAN
FsdFastIoPrepareMdlWrite (
    IN PFILE_OBJECT         FileObject,
    IN PLARGE_INTEGER       FileOffset,
    IN ULONG                Length,
    IN ULONG                LockKey,
    OUT PMDL                *MdlChain,
    OUT PIO_STATUS_BLOCK    IoStatus,
    IN PDEVICE_OBJECT       DeviceObject
    )
{
    KdPrint((DRIVER_NAME ": FASTIO_PREPARE_MDL_WRITE\n"));

    return FALSE;
}

BOOLEAN
FsdFastIoMdlWriteComplete (
    IN PFILE_OBJECT     FileObject,
    IN PLARGE_INTEGER   FileOffset,
    IN PMDL             MdlChain,
    IN PDEVICE_OBJECT   DeviceObject
    )
{
    KdPrint((DRIVER_NAME ": FASTIO_MDL_WRITE_COMPLETE\n"));

    return FALSE;
}

NTSTATUS
FsdFastIoAcquireForModWrite (
    IN PFILE_OBJECT     FileObject,
    IN PLARGE_INTEGER   EndingOffset,
    OUT PERESOURCE      *ResourceToRelease,
    IN PDEVICE_OBJECT   DeviceObject
    )
{
    KdPrint((DRIVER_NAME ": FASTIO_ACQUIRE_FOR_MOD_WRITE\n"));

    return STATUS_SUCCESS;
}

NTSTATUS
FsdFastIoReleaseForModWrite (
    IN PFILE_OBJECT     FileObject,
    IN PERESOURCE       ResourceToRelease,
    IN PDEVICE_OBJECT   DeviceObject
    )
{
    KdPrint((DRIVER_NAME ": FASTIO_RELEASE_FOR_MOD_WRITE\n"));

    return STATUS_SUCCESS;
}

NTSTATUS
FsdFastIoAcquireForCcFlush (
    IN PFILE_OBJECT     FileObject,
    IN PDEVICE_OBJECT   DeviceObject
    )
{
    KdPrint((DRIVER_NAME ": FASTIO_ACQUIRE_FOR_CC_FLUSH\n"));

    return STATUS_SUCCESS;
}

NTSTATUS
FsdFastIoReleaseForCcFlush (
    IN PFILE_OBJECT     FileObject,
    IN PDEVICE_OBJECT   DeviceObject
    )
{
    KdPrint((DRIVER_NAME ": FASTIO_RELEASE_FOR_CC_FLUSH\n"));

    return STATUS_SUCCESS;
}

BOOLEAN
FsdFastIoQueryOpen (
    IN PIRP                             Irp,
    OUT PFILE_NETWORK_OPEN_INFORMATION  NetworkInformation,
    IN PDEVICE_OBJECT                   DeviceObject
    )
{
    KdPrint((DRIVER_NAME ": FASTIO_QUERY_OPEN\n"));

    return FALSE;
}
